var connectionOk = true;
var productMgr = null;
var categoryMgr = null;
var jsonCities = null;
var jsonSchedule = null;
var firstCloseMsg = true;
var url = 'http://taxiya.elasticbeanstalk.com/';
var urlNew = 'http://apparty.colombiapps.com.co/';
//var urlNew = 'http://192.168.1.2:8000/';
var adsShown = false;

app.initialize();

//Called only when the page is loaded
$(document).on("pageshow", "#prodListPage", function (event, ui){
	
	//if (ui.prevPage.attr('id') == 'categories') {
		
		$("#categoryTitle").html(productMgr.category);
		
		productMgr.getProducts();
		
		showBasket();
		
		
	//}
	//$.mobile.loading("hide");
});

//Called only when the page is loaded
$(document).on("pageshow", "#orderSummary", function (event, ui){
	
	if (productMgr.successOrder) {
		$('#continueOrder').hide();
		$('#newOrder').css('visibility', 'visible');
	}
	
	productMgr.orderSummary();
	/*
	if (ui.prevPage.attr('id') == 'categories') {
		
		$("#categoryTitle").html(productMgr.category);
		
		productMgr.getProducts();
		
		//showBasket();
	}*/
	//showBasket();
	
});

//Called only when the page is loaded
$(document).on("pageshow", "#finishOrder", function (){
	
	if(window.localStorage.getItem("itemsId") !== null){
		
		$("#txtUserName").val(window.localStorage.getItem("username"));
		$("#txtPhone").val(window.localStorage.getItem("phone"));
		$("#txtAddress").val(window.localStorage.getItem("address"));
	}
	
	//$(".totalPrice").html(productMgr.orderValue);
	
	var shiping = 0;
	if (productMgr.orderValue < productMgr.minOrderValue) {
		
		shiping = productMgr.shippingCost;
	} 
			
	$('#finishTotal').html('<fieldset class="ui-grid-a">'+
								'<div class="ui-block-a" style="text-align: right;">'+
									'<span>Pedido<br>Domicilio<br>TOTAL</span></div>'+
								'<div class="ui-block-b" style="text-align: left;">'+
									'<span>: '+productMgr.orderValue+'<br>: '+shiping+'<br>: '+(productMgr.orderValue+shiping)+'</span>'+
								'</div></fieldset>');
	
	$('.ui-page').css('height', ($('[data-role="content"]').height()+70)+'px').trigger('create');
});

//Called only when the page is loaded
$(document).on("pageshow", "#categories", function (event, ui){
	
	var html = '<ul data-role="listview" data-inset="true" style="min-width:210px;" data-theme="a">'+
					'<li data-role="divider" data-theme="c">Escoge tu ciudad</li>';
	
	$(jsonCities).each(function(i,val){
		
		html += '<li><a href="#" onclick="productMgr.setCity(\''+val.name+'\'); return false" rel="external">'+val.name+'</a></li>';
	});
	
	html += '</ul>';
	
	$('#citiesListview').html(html).trigger('create');
	
	if (jsonSchedule != null && firstCloseMsg) {
		showSchedulePop(jsonSchedule);
		
		firstCloseMsg = false;
	}
	
	showCategories(ui);
	
});

//Called only when the page is loaded
$(document).on("pageshow", "#cityPage", function (event, ui){
	
	if (productMgr == null) {
		productMgr = new ProductMgr();
	}
	
	jsonSchedule = null;
	firstCloseMsg = true;
	
	getCities();
});

//Called only when the page is loaded
$(document).on("pageshow", "#loadingPage", function (event, ui){
	
	if (productMgr == null) {
		productMgr = new ProductMgr();
	}
	
	jsonSchedule = null;
	firstCloseMsg = true;
	
	getFirstInfo();
});

$(document).on("pageshow", "#termsPage", function (){
	
	$('.ui-page').css('height', ($('[data-role="content"]').height()+150)+'px');
	
});

function goTo(goToPage, reverse){
	
	//$.mobile.loading("show");
	
	if (goToPage == 'categories') {
	
		$.mobile.changePage( goToPage+'.html', { reverse: reverse });
		
	}else{
		$.mobile.changePage( goToPage, { reverse: reverse });
	}
}

function showBasket(){
	if (productMgr.itemsOrder !== null) {
		
		$('.basket').css('visibility', 'visible');
		
		$('.basket').append('<span class="basketCount">'+productMgr.itemsCount+'</span>');
		
		if (productMgr.plusTen) {
			$('.basketCount').css('right', '10px');
		}
	}
	
	$('.totalPrice').html(productMgr.orderValue);
}

/**
 * Share the point, using a plugin
 */
function shareApp(){
	
	// note: instead of available(), you could also check the useragent (android or ios6+)
	window.plugins.socialsharing.available(function(isAvailable) {
	  if (isAvailable) {
		
		  if (device.platform == 'ios' || device.platform == 'IOS' || device.platform == 'iOS') {
			  window.plugins.socialsharing.share('Apparty y sigue la rumba!', null, null, 'https://itunes.apple.com/co/app/apparty/id777896894');
		  }else if (device.platform == 'Android' || device.platform == 'android') {
			  window.plugins.socialsharing.share('Apparty y sigue la rumba!', null, null, 'https://play.google.com/store/apps/details?id=com.colombiapps.apparty');
		  }
	  }
	});	
}

function showCategories(ui){
	
	$('#cityBtn').html('<a href="#popupCity" data-rel="popup" data-role="button" data-mini="true" data-inline="true">'+window.localStorage.getItem("city")+'</a>');
	
	if (ui.prevPage.attr('id') == 'loadingPage') {
		
		$('#loadingPage').remove();
	}
	showBasket();
	
	if (categoryMgr == null) {
		categoryMgr = new CategoriesMgr();
	}
	
	categoryMgr.showCategories();
	
}

/**
 * Get the first info: categoriesId, productsId and ads
 */
function getFirstInfo(){
		
	//console.log('getAds! '+window.localStorage.getItem("city"));
	
	$.post( urlNew+'getFirstInfo', 
			{ city: window.localStorage.getItem("city")})
		.done( function(json) {
	    				
			if (json.success) {
				
				if(json.cities.constructor === String){
					jsonCities = $.parseJSON(json.cities);
			    }else{
			    	jsonCities = json.cities;
			    }
				
				if (json.img != 'noAds') {
								
					var img = new Image();
					// image onload
			        $(img).load(function () {
						
			        	$('.appartyAds').html(this);
			        	
			        	$('.ui-page').append('<div class="box-text bottom-text roundedCorners center-text"><strong>Cargando productos</strong><div class="spinner"><div class="bounce1"></div><div class="bounce2"></div><div class="bounce3"></div></div></div>');
			    
			        	//console.log(json.imgBase64+' // '+json.showTime);
			        	
			        }).error(function () {
			        	adsShown = true;
			        	
			        	//goHome();
			        	
			        }).attr('src', /*'data:image/jpg;base64,'+*/json.img).attr('width', 'auto').attr('height', '97%').addClass('roundedCorners').addClass('center');
				
			        setTimeout(function(){
						
		        		adsShown = true;
		        		
		        		var actualCity = window.localStorage.getItem("city");
						var stillActive = false;
						$(jsonCities).each(function(i,val){
							
							if (actualCity == val.name) {
								stillActive = true;
							}
						});
						//Si la ciudad ya no esta activa
						if (!stillActive) {
							goTo('chooseCity.html', false);
						}else{
							//Voy al server a revisar si el XML con los articulos ha cambiado
							productMgr.checkProducts();
						}
						
					}, json.showTime);
			        
				}else{
					adsShown = true;
					
					var actualCity = window.localStorage.getItem("city");
					var stillActive = false;
					$(jsonCities).each(function(i,val){
						
						if (actualCity == val.name) {
							stillActive = true;
						}
					});
					//Si la ciudad ya no esta activa
					if (!stillActive) {
						goTo('chooseCity.html', false);
					}else{
						//Voy al server a revisar si el XML con los articulos ha cambiado
						productMgr.checkProducts();
					}					
				}
				
				if (!json.schedule.open) {
					
					jsonSchedule = json.schedule.schedule;
				}
							
				if (device.platform === 'iOS' || device.platform === 'ios' || device.platform === 'IOS') {
	        		//Hide splash
	    	    	app.hideSplash();
	        	}
				
			}else{
				setTimeout(getFirstInfo, 1500);
			}
			
	    })
	    .fail( function(xhr, textStatus, errorThrown) {
	    	
	    	setTimeout(getFirstInfo, 1500);
	    });
}

function goHome(){
	
	//console.log('goHome '+adsShown);
	
	if (adsShown) {
		
		$.mobile.changePage( 'categories.html', {transition: 'fade'} );
		
		if (device.platform === 'iOS' || device.platform === 'ios' || device.platform === 'IOS') {
    		//Hide splash
	    	app.hideSplash();
    	}
		
	}else{
		setTimeout(function(){
			
			goHome();
		}, 1000);
	}
}

function getCities(){
	
	console.log(urlNew+'allCities');
	//Ajax call
	$.post( urlNew+'allCities', {} )
		.done( function(json) {
			  
			if(json.constructor === String){
				json = $.parseJSON(json);
		    }
			
			jsonCities = json;
			
			var html = '<option value="">Seleccione...</option>';
			
			$(json).each(function(i,val){
				
				html += '<option value="'+val.name+'">'+val.name+'</option>';
			});
			
			$('#select-city').html(html).selectmenu( "refresh", true );
	    })
	    .fail( function(xhr, textStatus, errorThrown) {
	    	
	    	console.log('falla: '+xhr.responseText+' // '+textStatus+' // '+errorThrown);
	    	
	    	setTimeout(function(){
				
	    		getCities();
				
			}, 1500);
	    });
}

function showSchedulePop(schedule){
	
	var target = $( this );
	var popup = '<div data-role="popup" id="schedulePop" data-theme="none" data-overlay-theme="b" data-corners="false" data-tolerance="15" data-dismissible="false">'+
					'<div style="background: black; color: white; text-shadow: none; text-align: center; padding: 5px;">'+
						'<div style="color: #cae000; font-weight: bold; padding: 10px 0; font-size: 1.5em;">Horario</div>'+
						'<div style="font-size: 1.2em;">'+
							'<p>';
	
	var dayArray = ['L', 'M', 'X', 'J', 'V', 'S', 'D'];
	
	for (var i = 0; i < dayArray.length; i++) {
		
		if (schedule[dayArray[i]].indexOf("pm") > -1) {
			
			popup += schedule[dayArray[i]] + '<br>';
		}
	}
		
	popup += 				'</p>'+
						'</div>'+
						'<p style="font-size: 1em; padding: 5px;">Se atiende el domingo si es lunes FESTIVO</p>'+
						'<div style="padding-bottom: 10px;" onclick="$( \'#schedulePop\' ).popup( \'close\' );">'+
							'<span style="color: white; border: 1px solid #cae000; font-weight: bold; padding: 5px 10px;" class="roundedCorners">Aceptar</span>'+
						'</div>'+
					'</div>'+
				'</div>';
		
	//	Create the popup.
	$( popup ).appendTo( $.mobile.activePage ).popup();

	//Fallback in case the browser doesn't fire a load event
	var fallback = setTimeout(function() {
		$.mobile.loading("hide");
		$( "#schedulePop" ).popup( "open" );
	}, 500);

	//Remove the popup after it has been closed to manage DOM size
	$( document ).on( "popupafterclose", ".ui-popup", function() {
		$( this ).remove();
	}); 
}
