function notification(msg, title, btnName){
	
	// Android / BlackBerry WebWorks (OS 5.0 and higher) / iPhone / Tizen
	//
	function alertDismissed() {
	    // do something
		
	}
		
	navigator.notification.alert(
		msg, 				  // message
	    alertDismissed,       // callback
	    title,                // title
	    btnName               // buttonName
	);
}

function notiExit(){
	
	// process the confirmation dialog result
	function onConfirm(button) {
	    
		$.mobile.loading("hide");
		
		if (button == 1) {
			try {
				navigator.app.exitApp();
			} catch (e) {
				// TODO: handle exception
			}
		}
	}
			
	// Show a custom confirmation dialog
	//
    navigator.notification.confirm(
        'Desea salir de Apparty?', // message
        onConfirm,                // callback to invoke with index of button pressed
        'Confirmar',              // title
        ['Si','No']          		  // buttonLabels
    );
}

function notiShipping(){
	
	// process the confirmation dialog result
	function onConfirm(button) {
	    
		if (button == 1) {
			goTo('finishOrder.html', false);
		}
	}
		
	if (productMgr.orderValue < productMgr.minOrderValue) {
		
		// Show a custom confirmation dialog
		//
	    navigator.notification.confirm(
	        'Tu pedido es inferior a '+productMgr.minOrderValue+', por esto el domicilio NO es gratis y tiene un valor de '+productMgr.shippingCost, // message
	        onConfirm,                // callback to invoke with index of button pressed
	        'Domicilio',              // title
	        ['Continuar','Volver']          		  // buttonLabels
	    );
		
	} else {
		goTo('finishOrder.html', false);
	}
}

function notiSuccessOrder(msg){
	
	// process the confirmation dialog result
	function onConfirm(button) {
	    
		if (button == 2) {
			shareApp();
		}
	}
	
	// Show a custom confirmation dialog
	//
    navigator.notification.confirm(
        msg, // message
        onConfirm,                	// callback to invoke with index of button pressed
        'Aviso',           			// title
        ['Aceptar','Compartir'] // buttonLabels
    );
}
